using PlumbingRepairContracts.BindingModels;
using PlumbingRepairContracts.ViewModels;
using PlumbingRepairDataModels.Models;
using System.ComponentModel.DataAnnotations.Schema;
using System.ComponentModel.DataAnnotations;
using System.Runtime.Serialization;

namespace PlumbingRepairDatabaseImplement.Models
{
	[DataContract]
	public class Implementer : IImplementerModel
	{
		[DataMember]
		public int Id { get; set; }

		[Required]
		[DataMember]
		public string ImplementerFIO { get; set; } = string.Empty;

		[Required]
		[DataMember]
		public string Password { get; set; } = string.Empty;

		[Required]
		[DataMember]
		public int WorkExperience { get; set; }

		[Required]
		[DataMember]
		public int Qualification { get; set; }

		[ForeignKey("ImplementerId")]
		public virtual List<Order> Orders { get; set; } = new();

		public static Implementer? Create(ImplementerBindingModel model)
		{
			if (model == null)
			{
				return null;
			}
			return new Implementer()
			{
				Id = model.Id,
				ImplementerFIO = model.ImplementerFIO,
				Password = model.Password,
				WorkExperience = model.WorkExperience,
				Qualification = model.Qualification
			};
		}
		public void Update(ImplementerBindingModel model)
		{
			if (model == null)
			{
				return;
			}
			ImplementerFIO = model.ImplementerFIO;
			Password = model.Password;
			WorkExperience = model.WorkExperience;
			Qualification = model.Qualification;
		}
		public ImplementerViewModel GetViewModel => new()
		{
			Id = Id,
			ImplementerFIO = ImplementerFIO,
			Password = Password,
			WorkExperience = WorkExperience,
			Qualification = Qualification
		};
	}
}
